
#ifndef CPP_UNIT_EXAMPLETESTCASE_H
#define CPP_UNIT_EXAMPLETESTCASE_H

#include <cppunit/extensions/HelperMacros.h>
#include "../../BustaSandwich/engine/BustaEngine.h"
#include "../../BustaSandwichd/BustaNetServer.h"


/* 
 * A test case that is designed to produce
 * example errors and failures
 *
 */

class ExampleTestCase : public CPPUNIT_NS::TestFixture
{
	CPPUNIT_TEST_SUITE( ExampleTestCase );
	CPPUNIT_TEST( testConnection );
	//CPPUNIT_TEST( testMovePieces ); //non-working
	//CPPUNIT_TEST( testSwapAndSubmit ); //non-working
	CPPUNIT_TEST_SUITE_END();

public:
	void setUp();
	void tearDown();

protected:
	BustaEngine* engine;
	BustaNetServer* server;

	void testConnection();
	void testMovePieces();
	void testSwapAndSubmit();

private:
	int pushEvent(SDLKey sym);
};


#endif
