
#ifndef CPP_UNIT_EXAMPLETESTCASE_H
#define CPP_UNIT_EXAMPLETESTCASE_H

#define NULL 0

#include <cppunit/extensions/HelperMacros.h>
#include "../../../BustaSandwich/engine/BustaEngine.h"

/* 
 * A test case that is designed to produce
 * example errors and failures
 *
 */

class ExampleTestCase : public CPPUNIT_NS::TestFixture
{
	CPPUNIT_TEST_SUITE( ExampleTestCase );
	CPPUNIT_TEST( testChef );
	CPPUNIT_TEST( testTipJar );
	CPPUNIT_TEST( testPosition );
	CPPUNIT_TEST( testCursor );
	CPPUNIT_TEST( testFoodPiece );
	CPPUNIT_TEST( testOpponent );
    CPPUNIT_TEST( testCompleteSandwich );
	CPPUNIT_TEST( testGameState );
	CPPUNIT_TEST( testCustomer );
	CPPUNIT_TEST( testMPGameState );
	CPPUNIT_TEST_SUITE_END();

public:
	void setUp();
	void tearDown();

protected:
	BustaModelChef* chef;
	BustaModelTipJar* tipjar1;
	BustaModelTipJar* tipjar2;
	BustaModelPosition* pos;
	BustaModelPosition* pos1;
	BustaModelCursor* cursor;
	BustaModelFoodPiece* fp1;
	BustaModelFoodPiece* fp2;
	BustaModelOpponent* opp1;
	BustaModelOpponent* opp2;
	BustaModelCompleteSandwich* csw;
	BustaModelGameState* gs;
	BustaModelCustomer* cust;
	BustaModelOpponent* opptr[2];
	BustaModelMPGameState* mpgs;

	void testChef();
	void testTipJar();
	void testPosition();
	void testCursor();
	void testFoodPiece();
	void testOpponent();
	void testCompleteSandwich();
	void testGameState();
	void testCustomer();
	void testMPGameState();
	
};


#endif
