
#ifndef CPP_UNIT_EXAMPLETESTCASE_H
#define CPP_UNIT_EXAMPLETESTCASE_H

#include <string.h>
#include <cppunit/extensions/HelperMacros.h>
#include "../../../BustaSandwich/engine/BustaEngine.h"

/* 
 * A test case that is designed to produce
 * example errors and failures
 *
 */

class ExampleTestCase : public CPPUNIT_NS::TestFixture
{
	CPPUNIT_TEST_SUITE( ExampleTestCase );
	CPPUNIT_TEST( testsendCharSelect );
	CPPUNIT_TEST( testsendCursor );
	CPPUNIT_TEST( testsendGameOver );
	CPPUNIT_TEST( testsendOpponentViewReq );
	CPPUNIT_TEST( testsendReady );
	CPPUNIT_TEST( testsendSandwich );
	CPPUNIT_TEST( testsendState );
	CPPUNIT_TEST( testjoinGame1 );
	CPPUNIT_TEST( testjoinGame2 );
	CPPUNIT_TEST( testjoinGame3 );
	CPPUNIT_TEST( testreceiveGameStates );
	CPPUNIT_TEST( testreceiveStartGame );
	CPPUNIT_TEST( testreceiveDisconnect );
	CPPUNIT_TEST( testreceiveCharSelectMode );
	CPPUNIT_TEST( testreceivePlayerLost );
	CPPUNIT_TEST( testreceiveCharSelection );
	CPPUNIT_TEST( testreceiveCharSelectCursor );
	CPPUNIT_TEST( testreceiveSpecialSandwich );
	CPPUNIT_TEST( testreceiveNewConnection );
	CPPUNIT_TEST( testreceivePlayerReady );
	CPPUNIT_TEST( testreceiveError );
	CPPUNIT_TEST( testreceiveManyMsgs );
	CPPUNIT_TEST_SUITE_END();

public:
	void setUp();
	void tearDown();

protected:
	BustaNetClient* client;

	IPaddress serverIP;	
	TCPsocket servsock;
	TCPsocket clientsock;

	void testsendCharSelect();
	void testsendCursor();
	void testsendGameOver();
	void testsendOpponentViewReq();
	void testsendReady();
	void testsendSandwich();
	void testsendState();
	void testjoinGame1();		// short player name
	void testjoinGame2();		// long player name
	void testjoinGame3();		// Simulated server response
	void testreceiveGameStates();
	void testreceiveStartGame();
	void testreceiveDisconnect();
	void testreceiveCharSelectMode();
	void testreceivePlayerLost();
	void testreceiveCharSelection();
	void testreceiveCharSelectCursor();
	void testreceiveSpecialSandwich();
	void testreceiveNewConnection();
	void testreceivePlayerReady();
	void testreceiveError();
	void testreceiveManyMsgs();
};


#endif
