
#ifndef CPP_UNIT_EXAMPLETESTCASE_H
#define CPP_UNIT_EXAMPLETESTCASE_H

#include <cppunit/extensions/HelperMacros.h>
#include "../../BustaSandwichd/BustaNetServer.h"

/* 
 * A test case that is designed to produce
 * errors and failures
 *
 */

class ExampleTestCase : public CPPUNIT_NS::TestFixture
{
	CPPUNIT_TEST_SUITE( ExampleTestCase );
	CPPUNIT_TEST( testSetMaxClients );
	CPPUNIT_TEST( testSetName );
	CPPUNIT_TEST( testSendAccept );
	CPPUNIT_TEST( testSendCharacterSelectedAllO );
	CPPUNIT_TEST( testSendCharacterSelectCursorAllO );
	CPPUNIT_TEST( testSendCharacterSelectModeAll );
	CPPUNIT_TEST( testSendDisconnectedAllO );
	CPPUNIT_TEST( testSendEndAll );
	CPPUNIT_TEST( testSendGameStartAll );
	CPPUNIT_TEST( testSendPlayerLostAllO );
	CPPUNIT_TEST( testSendSandwichAllO );
	CPPUNIT_TEST( testSendUpdateAll );
	CPPUNIT_TEST( testSetStateAccept );
	CPPUNIT_TEST( testSetStateCharSelect );
	CPPUNIT_TEST( testSetStateGame );
	CPPUNIT_TEST_SUITE_END();

public:
	void setUp();
	void tearDown();

protected:
	BustaNetServer* server;
	IPaddress serverIP;	
	TCPsocket client_one;
	TCPsocket client_two;

	char type;

	void testSetMaxClients();
	void testSetName();
	void testSendAccept();
	void testSendCharacterSelectedAllO();
	void testSendCharacterSelectCursorAllO();
	void testSendCharacterSelectModeAll();
	void testSendDisconnectedAllO();
	void testSendEndAll();
	void testSendGameStartAll();
	void testSendPlayerLostAllO();
	void testSendSandwichAllO();
	void testSendUpdateAll();
	void testSetStateAccept();
	void testSetStateCharSelect();
	void testSetStateGame();
};


#endif
