#include "BustaEngine.h"

BustaEngine::BustaEngine(){
	pause = 5000;		//time between first keydown and repeating, in ms
	interval = 1000;		//interval between repeating key events (ms)	
	myID = -1;
	multiplayer = false;
	gameover = false;
	confusedTime = 20;
	confusedTimer = 0;
	srand((unsigned)time(NULL));


	ROTATE = SDLK_a;
	SWAP = SDLK_s;
	DOWN = SDLK_DOWN;
	UP = SDLK_UP;
	RIGHT = SDLK_RIGHT;
	LEFT = SDLK_LEFT;
	QUIT = SDLK_ESCAPE;
	SUBMIT_CUST = SDLK_q;
	SUBMIT_SELF = SDLK_w;
	SUBMIT_OPPONENT = SDLK_e;

		// init SDL
	if (SDL_Init(SDL_INIT_TIMER) == -1)
	{
		printf("SDL_Init: %s\n", SDL_GetError());
	}

	int enableRepeat = SDL_EnableKeyRepeat(0,interval);

	if(enableRepeat==-1)
		printf("Error enabling key repeat");


	//High score loading crap

	//dummy values
	HSnames = new char*[10];
	for(int i=0;i<10;i++){
		HSnames[i] = new char[20];
		sprintf(HSnames[i],"The Gimp");
		HSscores[i] = 0;
	}

	fstream file (HIGHSCORE_PATH);
	if(! file.is_open())
		printf("Error opening High Scores File.\n");
	else{
		for(int i=0;i<10;i++){
			file.getline(HSbuffer,20);
			sprintf(HSnames[i],"%s",HSbuffer);
			file.getline(HSbuffer,20);
			HSscores[i] = atoi(HSbuffer);
		}
	file.close();
	}
	/*for(int i=0;i<10;i++){
		printf("%s , %d\n",HSnames[i],HSscores[i]);
	}*/


	state = MAIN_MENU;

	// ------------------- SPECIAL SANDWICH DEFINITIONS -------------------
	ssLoseWeight = new FoodType[WIDTH];
	ssLoseWeight[0] = TOMATO;
	ssLoseWeight[1] = LETTUCE;
	ssLoseWeight[2] = TOFU;
	ssLoseWeight[3] = PICKLES;
	ssLoseWeight[4] = ONION;

	ssFreshen = new FoodType[WIDTH];
	ssFreshen[0] = TOMATO;
	ssFreshen[1] = LETTUCE;
	ssFreshen[2] = CHICKEN;
	ssFreshen[3] = MUSTARD;
	ssFreshen[4] = CHEESE;

	ssEnergyBoost = new FoodType[WIDTH];
	for (int i = 0; i <	WIDTH; i++)
		ssEnergyBoost[i] = (FoodType)(rand() % NUMFOODPIECES);	// randomize

	ssSteal = new FoodType[WIDTH];
	ssSteal[0] = SALAMI;
	ssSteal[1] = HAM;
	ssSteal[2] = MAYO;
	ssSteal[3] = ONION;
	ssSteal[4] = TURKEY;
		
	ssGainWeight = new FoodType[WIDTH];
	ssGainWeight[0] = SALAMI;
	ssGainWeight[1] = CHICKEN;
	ssGainWeight[2] = TURKEY;
	ssGainWeight[3] = HAM;
	ssGainWeight[4] = CHEESE;

	ssSpoil = new FoodType[WIDTH];
	ssSpoil[0] = ONION;
	ssSpoil[1] = CHEESE;
	ssSpoil[2] = MAYO;
	ssSpoil[3] = PICKLES;
	ssSpoil[4] = MUSTARD;

	ssJumble = new FoodType[WIDTH];
	ssJumble[0] = TOMATO;
	ssJumble[1] = ONION;
	ssJumble[2] = TOFU;
	ssJumble[3] = TURKEY;
	ssJumble[4] = CHICKEN;

	ssConfuse = new FoodType[WIDTH];
	ssConfuse[0] = CHEESE;
	ssConfuse[1] = HAM;
	ssConfuse[2] = LETTUCE;
	ssConfuse[3] = MUSTARD;
	ssConfuse[4] = PICKLES;

	ssEnergyZap = new FoodType[WIDTH];
	ssEnergyZap[0] = SALAMI;
	ssEnergyZap[1] = TOFU;
	ssEnergyZap[2] = MAYO;
	ssEnergyZap[3] = HAM;
	ssEnergyZap[4] = MUSTARD;
	// ---------------- END SPECIAL SANDWICH DEFINITIONS -------------------

	int numSandwiches = NOTASANDWICH;

	FoodType** SpecSand = new FoodType*[numSandwiches];
	char** SandNames = new char*[numSandwiches];

	SpecSand[0] = ssLoseWeight;
	SpecSand[1] = ssFreshen;
	SpecSand[2] = ssEnergyBoost;
	SpecSand[3] = ssSteal;
	SpecSand[4] = ssGainWeight;
	SpecSand[5] = ssSpoil;
	SpecSand[6] = ssJumble;
	SpecSand[7] = ssConfuse;
	SpecSand[8] = ssEnergyZap;

	SandNames[0] = "Lose Weight";
	SandNames[1] = "Freshen Ingredients";
	SandNames[2] = "Energy Boost";
	SandNames[3] = "Steal";
	SandNames[4] = "Gain Weight";
	SandNames[5] = "Spoil";
	SandNames[6] = "Jumble";
	SandNames[7] = "Confuse";
	SandNames[8] = "Energy Zap";


	network = new BustaNetClient();

	graphics = new BustaGraphics(SpecSand,SandNames,numSandwiches,NUM_SP_SPECSAND);

	printf("num sand %d, num sp sand %d",numSandwiches, NUM_SP_SPECSAND);

	gs = new BustaModelGameState();
	showSandwichMenu = true;
}

BustaEngine::~BustaEngine(){
	delete network;
	delete graphics;
	delete gs;

	SDL_Quit();

	// --------------- DELETE SPECIAL SANDWICH DEFINITIONS -------------------
	delete [] ssLoseWeight;
	delete [] ssFreshen;
	delete [] ssSteal;
	delete [] ssEnergyBoost;
	delete [] ssGainWeight;
	delete [] ssSpoil;
	delete [] ssJumble;
	delete [] ssConfuse;
	delete [] ssEnergyZap;

}

ScreenState BustaEngine::getState(){
	return state;
}

void BustaEngine::setState(ScreenState s){
	state = s;
}

void BustaEngine::mainMenu(){
	const int I_PICK = SDLK_RETURN;
	const int I_UP = SDLK_UP;
	const int I_DOWN = SDLK_DOWN;

	printf("main menu");

	MainScrnButton button = MS_START_SP;
	
	graphics->drawMainScreen(button);

	bool done = false;
	SDL_Event event;


	while(!done)
	{
		SDL_Delay(20);
		//graphics->drawMainScreen(button);

		if( SDL_PollEvent(&event))
		{
			graphics->drawMainScreen(button);
			switch(event.type){
				case SDL_KEYDOWN:
					//printf("We got a keyboard event %d.\n", event.key.keysym.sym);
					if(event.key.keysym.sym==I_PICK){
						done = true;
						state = MainScreenChangeState(button);
					}
					else if(event.key.keysym.sym==I_UP){
						//printf("moving up");
						button= (MainScrnButton)((button-1+MS_NUM_BUTTONS)%MS_NUM_BUTTONS);
					}
					else if(event.key.keysym.sym==I_DOWN){
						button= (MainScrnButton)((button+1)%MS_NUM_BUTTONS);
					}
					break;
				case SDL_MOUSEMOTION:
					for(int i =0; i<MS_NUM_BUTTONS; i++){
						if(buttonSelected(graphics->bMainScrn[i],event.motion.x,event.motion.y)){
							button = (MainScrnButton)i;
							break;
						}
					}
					break;
				case SDL_MOUSEBUTTONUP:
					if(event.button.button==SDL_BUTTON_LEFT&&buttonSelected(graphics->bMainScrn[button],event.button.x,event.button.y)){
						done = true;
						state = MainScreenChangeState(button);
					}
					break;
				case SDL_QUIT:
					done = true;
					state = EXIT;
				default:
					//printf("Unknown input, try again!\n");
					break;
			}
		}
	}
}

ScreenState BustaEngine::MainScreenChangeState(MainScrnButton button){
	switch(button){
		case MS_START_SP:
			printf("Going to character select(SP) screen\n");
			multiplayer = false;
			return CHAR_SELECT;
			break;
		case MS_START_MP:
			printf("Going to connect screen\n");
			multiplayer = true;
			return CONNECT;
			break;
		case MS_HIGH_SCORE:
			printf("Going to high scores screen\n");
			return HIGH_SCORES;
			break;
		case MS_OPTIONS:
			printf("Going to high scores screen\n");
			return OPTIONS;
			break;
		case MS_QUIT:
			printf("Exiting loop\n");
			return EXIT;
			break;
		default:
			return MAIN_MENU;
	}
}

void BustaEngine::optionsMenu(){
	const int I_KEY_BINDINGS = SDLK_k;
	const int I_SOUNDS = SDLK_s;
	const int I_DIFFICULTY = SDLK_d;
	const int I_MAIN_MENU = SDLK_m;
	
	printf("entered options menu\n");

	KeyBindingsActionListener* listener = new KeyBindingsActionListener(this);


	graphics->initKeyBindingScrn(listener);

	bool done = false;

	SDL_Event event;

	// while options menu not implemented...
	//done = true;
	//state = MAIN_MENU;
	// 

	settingkeybinding = false;

	while(!done)
	{	

		SDL_Delay(20);

		
		graphics->drawKeyBindingScrn(settingkeybinding);

		if( SDL_PollEvent(&event))
		{

			graphics->handleGUIEvent(&event);

			

			switch(event.type){
				case SDL_KEYDOWN:
					if(settingkeybinding){
						
						graphics->drawKeyBindingScrn(settingkeybinding);
						printf("setting key: %d\n",settingkeybinding);

						switch(key){
							case 0:
								ROTATE = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 1:
								SWAP = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 2:
								DOWN = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 3:
								UP = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 4:
								RIGHT = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 5:
								LEFT = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 6:
								SUBMIT_CUST = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 7:
								SUBMIT_SELF  = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							case 8:
								SUBMIT_OPPONENT = event.key.keysym.sym;
								settingkeybinding = false;
								break;
							default:
								break;
						}
					}
					break;
				case SDL_QUIT:
					done = true;
					state = EXIT;
					break;
				default:
					break;
			}
		}

		if(state!=OPTIONS)
			done = true;
	} 


}

void BustaEngine::highScores(){
	const int I_OK = SDLK_o;

	printf("entered high scores menu\n");

	HighScoresActionListener* listener = new HighScoresActionListener(this);

	graphics->initHighScores(listener);

	// should be false, this to keep working while
	// screen not implemented
	bool done = false;
//	state = MAIN_MENU;
	// state should not be changed once implemented


	SDL_Event event;

	while(!done)
	{

		SDL_Delay(20);

		graphics->drawHighScores(HSnames, HSscores);
		

		if ( SDL_PollEvent(&event))
		{
			graphics->handleGUIEvent(&event);

			switch(event.type){
				case SDL_QUIT:
					printf("Going back to Main Menu\n");
					state = MAIN_MENU;
					done = true;			
					break;
				default:
					break;
			}
		}
		if(state!=HIGH_SCORES)
			done = true;
	} 
}

void BustaEngine::characterSelectMP(){
	printf("entered character select screen\n");

	BustaModelPosition* myCursor = new BustaModelPosition(0,0);
	
	BustaNetMsgQ* priority;
	BustaNetInternalMsg* message;
	SDL_Event event;
	int type;
	bool nextscreen = false;
	numPlayers = network->getPlayerCount();
	maxPlayers = network->getMaxPlayers();

	rankings = new int[maxPlayers];
	scores = new int[maxPlayers];


	myID = network->getClientID();

	BustaModelPosition** cursors = new BustaModelPosition*[numPlayers];

	int* cursors_x = new int[numPlayers-1];
	int* cursors_y = new int[numPlayers-1];
	char** otherNames = new char*[numPlayers-1];

	mpCharacters = new BustaModelCharacter[numPlayers];

	printf("numplayers: %d\n",numPlayers);
	//set array elements to NULL initially
	for(int i = 0; i<numPlayers-1; i++){
		cursors_x[i] = NULL;
		cursors_y[i] = NULL;
		cursors[i] = NULL;
		mpCharacters[i] = C0;
		
		if(i<myID){
			otherNames[i] = mpNames[i];
		}
		else{
			otherNames[i] = mpNames[i+1];
		}
	}

	mpCharacters[numPlayers-1] = C0;
	cursors[numPlayers-1] = NULL;
	cursors[myID]= myCursor;

	CharSelectActionListener* listener = new CharSelectActionListener(this,myCursor);
	
	graphics->initCharSelScrn(listener);
	
	while(!nextscreen){

		SDL_Delay(10);

		graphics->drawCharSelScrn(myCursor->getY(),myCursor->getX(),cursors_y, cursors_x,otherNames,numPlayers-1);
		
		if(SDL_PollEvent(&event)){
			graphics->handleGUIEvent(&event);

			switch(event.type){
				case SDL_KEYDOWN:
					if(event.key.keysym.sym==SDLK_LEFT){
						int x = myCursor->getX();
						if(x>0){
							x--;
							myCursor->setX(x);
							network->sendCursor(myCursor);
						}
					}
					else if(event.key.keysym.sym==SDLK_RIGHT){
						int x = myCursor->getX();
						if(x<3){
							x++;
							myCursor->setX(x);
							network->sendCursor(myCursor);
						}
					}
					else if(event.key.keysym.sym==SDLK_UP){
						if(myCursor->getY()==1){
							myCursor->setY(0);
							network->sendCursor(myCursor);
						}
					}
					else if(event.key.keysym.sym==SDLK_DOWN){
						if(myCursor->getY()==0){
							myCursor->setY(1);
							network->sendCursor(myCursor);
						}
					}
					else if(event.key.keysym.sym==SDLK_RETURN){
						BustaModelCharacter chef = selectChef(myCursor);
						network->sendCharSelect(chef);
						mpCharacters[myID] = chef;
						gs->getChef()->setCharacter(chef);
					}
					break;
				case SDL_QUIT:
					network->disconnect();
					state = EXIT;
				default:
					break;
			}
		}

		network->processNet();
		priority = network->getPriorityQ();
		message = priority->pop();

		int id;
		char* name;
		char* reason;

		if(message!=NULL){
			type = message->getType();
			
			BustaModelCharacter c;

			switch(type){
				case 3:
					id = ((MPPlayerDisconnect*)message)->getPlayerID();
					reason = ((MPPlayerDisconnect*)message)->getReason();
					if(id==myID){
						state = CONNECT;
					}
					else{
						if(id>myID){
							id--;
						}
						cursors[id] = NULL;
						cursors_x[id] = NULL;
						cursors_y[id] = NULL;
						printf("player %d disconnected\n",id);
					}
					break;
				case 101:		//character seleted
					id = ((MPCharSelected*)message)->getPlayerID();
					printf("player %d picked a character\n",id);
					c = ((MPCharSelected*)message)->getSelectedChar();
					printf("character %d\n", c );
					mpCharacters[id] = c;
					break;
				case 102:		//character selection cursor
					printf("cursor received");
					id = ((MPCharSelectCursor*)message)->getPlayerID();
					cursors[id] = ((MPCharSelectCursor*)message)->getCursor();
					if(id>myID){
						id--;
					}
					cursors_x[id] = ((MPCharSelectCursor*)message)->getCursor()->getX();
					cursors_y[id] = ((MPCharSelectCursor*)message)->getCursor()->getY();
					printf("cursor set\n");
					break;
				case 202:	//start game message received
					printf("start game received");
					state = MP_GAME;			
					break;
				case 666:
					printf("Error in message received\n");
					break;
				default:
					printf("Message of wrong type received, %d\n", type);
					break;
			}
		
			delete message;
			message = NULL;
		}

		if(state!=CHAR_SELECT){
			nextscreen = true;
		}
	}
	graphics->killCharSelScrn();
}


void BustaEngine::characterSelectSP(){
	printf("entered character select screen\n");

	BustaModelPosition* myCursor = new BustaModelPosition(0,0);
	SDL_Event event;
	int type;
	bool nextscreen = false;

	CharSelectActionListener* listener = new CharSelectActionListener(this,myCursor);
	graphics->initCharSelScrn(listener);
	
	while(!nextscreen){

		SDL_Delay(10);

		graphics->drawCharSelScrn(myCursor->getY(),myCursor->getX(),NULL, NULL,NULL,0);
		
		if(SDL_PollEvent(&event)){
			graphics->handleGUIEvent(&event);

			switch(event.type){
				case SDL_KEYDOWN:
					if(event.key.keysym.sym==SDLK_LEFT){
						int x = myCursor->getX();
						if(x>0){
							x--;
							myCursor->setX(x);
						}
					}
					else if(event.key.keysym.sym==SDLK_RIGHT){
						int x = myCursor->getX();
						if(x<3){
							x++;
							myCursor->setX(x);
						}
					}
					else if(event.key.keysym.sym==SDLK_UP){
						if(myCursor->getY()==1){
							myCursor->setY(0);
						}
					}
					else if(event.key.keysym.sym==SDLK_DOWN){
						if(myCursor->getY()==0){
							myCursor->setY(1);
						}
					}
					else if(event.key.keysym.sym==SDLK_RETURN){
						BustaModelCharacter chef = selectChef(myCursor);
						gs->getChef()->setCharacter(chef);
						state = SP_GAME;
					}
					break;
				case SDL_QUIT:
					state = EXIT;
				default:
					break;
			}
		}

		if(state!=CHAR_SELECT){
			nextscreen = true;
		}
	}
	graphics->killCharSelScrn();
}
BustaModelCharacter BustaEngine::selectChef(BustaModelPosition* cursor){
	switch(cursor->getX()){
		case 0:
			if(cursor->getY()==0){
				return C0;
			}
			else{
				return C4;
			}
			break;
		case 1:
			if(cursor->getY()==0){
				return C1;
			}
			else{
				return C5;
			}
			break;
		case 2:
			if(cursor->getY()==0){
				return C2;
			}
			else{
				return C6;
			}
			break;
		case 3:
			if(cursor->getY()==0){
				return C3;
			}
			else{
				return C7;
			}
			break;
		default: 
			return C0;
			break;
	}
}

void BustaEngine::connectScreen(){
	printf("entered connection screen\n");

	ConnectScrnActionListener* listener = new ConnectScrnActionListener(this);
	graphics->initConnectScrn(listener);

	c_state = CS_NOT_CONNECTED;
	myID = -1;

	SDL_Event event;
	bool done = false;
	bool readysent = false;
	ConnectScrnPlayerList* playersList = NULL;

	while(!done)
	{
		SDL_Delay(20);

		graphics->drawConnectScrn(c_state, playersList);
		
		while(SDL_PollEvent(&event)&&!done){
				
			SDL_Delay(20);
			char* name;
		
			graphics->drawConnectScrn(c_state, playersList);
		
			graphics->handleGUIEvent(&event);
		

			if(event.type==SDL_QUIT){
				state = EXIT;
				done = true;
				if(c_state==CS_CONNECTED||c_state==CS_READY){
					network->disconnect();
				}
			}
			if(c_state==CS_NOT_CONNECTED){
				readysent = false;
				
				if(playersList!=NULL){
				
					ConnectScrnPlayerList* current;

					while(playersList!=NULL){
						current = playersList->next;
						delete playersList;
						playersList = current;
					}
				}
			}
			else if(c_state==CS_CONNECTING){
				char* ip;
				char* name;
				char* ermsg;
				MPJoinResponse* joined;
				bool accepted = false;
				int nameLength;

				name = (char*)graphics->getConnectScrnTextField();
				printf("part 1: %s\n",name);
				for(int i = 0; i<21; i++){
					myName[i] = name[i];
					if(name[i] == NULL)
						break;
				}
				
				if(!networkInitialized){
					netInit();
					networkInitialized = true;
				}

				ip = (char*)graphics->getServerIPAddress();
				ermsg = connectIP(ip);

				if(ermsg!=NULL){
					printf("Error connecting to server because: %s\n",ermsg);
				}
				else{
					printf("joining game");
					SDL_Delay(2);
					joined = network->joinGame(myName);
					printf("joined one way or another");

					accepted = joined->getAcceptance();	

					printf("%s\n",joined->getReason());
					printf("%d",accepted);

					printf("%d",joined->getType());
					myID = joined->getClientID();
					printf("my id: %d\n",myID);
					
					if(accepted){
						printf("accepted");
						c_state = CS_CONNECTED;

						playersList = new ConnectScrnPlayerList();
				
						playersList->id = myID;
						playersList->name = myName;
						playersList->isReady = false;
						playersList->next = NULL;

					}
					else{
						c_state = CS_NOT_CONNECTED;
						printf("not connected");
					}
				}
			}

			else if(c_state == CS_CONNECTED||c_state == CS_READY)
			{	
				printf("loop");

				BustaNetMsgQ* priority;
				BustaNetInternalMsg* message = NULL;

				network->processNet();

				priority = network->getPriorityQ();
				
				bool startgame = false;

				int type;

				while(!startgame&&(c_state==CS_CONNECTED||c_state==CS_READY)){
				
					if(c_state==CS_READY&&!readysent){
						//printf("aobut to send ready message");
						readysent=true;
						network->sendReady();
						printf("sent ready message");
						playersList->isReady = true;
					}

					SDL_Delay(5);

					SDL_PollEvent(&event);

						
					if(event.type==SDL_QUIT){
						state = EXIT;
						done = true;
						if(c_state==CS_CONNECTED||c_state==CS_READY){
							network->disconnect();
						}
					}
					

					graphics->drawConnectScrn(c_state, playersList);
					graphics->handleGUIEvent(&event);

					network->processNet();
					priority = network->getPriorityQ();
					message = priority->pop();

					int id;
					char* name;
					char* reason;
					ConnectScrnPlayerList* current;
					ConnectScrnPlayerList* next;

					if(message!=NULL){
						type = message->getType();

						switch(type){
							case 2:
								id = ((MPNewPlayer*)message)->getPlayerID();
								name = ((MPNewPlayer*)message)->getPlayerName();
								
								
								current = playersList;
								next = playersList->next;
								
								while(next!=NULL){
									current = next;
									next = current->next;
								}
								next = new ConnectScrnPlayerList();
								next->id = id;
								next->name = name;
								next->isReady = false;
								current->next = next;
							
								break;
							case 3:
								id = ((MPPlayerDisconnect*)message)->getPlayerID();
								reason = ((MPPlayerDisconnect*)message)->getReason();
									
								printf("disconnect message received");

								current = playersList;
								next = playersList->next;

								while(next->id!=id&&next->next!=NULL){
									current = next;
									next = current->next;
								}

								if(next->id!=id){
									printf("Cannot disconnect player, not listed!");
								}
								else{
									current->next = next->next;
									delete next;
								}

								break;
							case 103:
								id = ((MPPlayerReady*)message)->getClientID();
									
								current = playersList;
								next = playersList->next;

								while(next->id!=id&&next->next!=NULL){
									current = next;
									next = current->next;
								}
								if(next->id!=id){
									printf("Cannot set player ready, not listed!");
								}
								else{
									next->isReady = true;	
								}
								break;
							case 201:
								printf("Char select mode");
								state = CHAR_SELECT;
								startgame = true;
								done = true;
                                break;
							case 666:
								printf("Error in message received\n");
								break;
							default:
								printf("Message of wrong type received, %d\n", type);
								break;
						}
					
						delete message;
						message = NULL;
					}
				}
			}

			else if (c_state==CS_CANCEL){
				done = true;
				state = MAIN_MENU;
				printf("c_state = CANCEL!");
			}
		}
	}

	printf("leaving connect screen");
	ConnectScrnPlayerList* current = playersList;

	int numPlayers = network->getPlayerCount();
	mpNames = new char*[numPlayers];

	while(playersList!=NULL){
		mpNames[playersList->id] = playersList->name;

		current = playersList->next;
		delete playersList;
		playersList = current;
	}
	graphics->killConnectScrn();
}

void BustaEngine::keyBindingMenu(){
	printf("entered key binding screen\n");
	state = OPTIONS;
}


void BustaEngine::soundsMenu(){
	printf("entered sounds menu\n");
	state = OPTIONS;
}


void BustaEngine::difficultyMenu(){
	printf("entered difficulty menu \n");
	state = OPTIONS;
}

void BustaEngine::playGame(){	
	printf("entered game loop");
	bool done = false;
	int col_curr = 0;
	int row_curr = 0;
	int align_curr = 0;
	int removed;
	int counter = 0;
	setOppGraphics = false;
	gameover = false;
	bool sentover = false;

	CFileTime oldtime;
	CFileTime newtime;
	oldtime = CFileTime::GetCurrentTime();
	newtime = CFileTime::GetCurrentTime();

	CFileTime delay;

	gcn::ActionListener* listener;

	for(int i = 0; i<numPlayers; i++){
		printf("Name: %s, ID: %d\n",mpNames[i],mpCharacters[i]);
	}

	//make sure that all of the foodpieces are fresh
	gs->updateFoodPieces(1);
	gs->updateFoodPieces(1);

	//make sure that all customers still have all of their time left
	for(int i = 0; i<NUMCUSTOMERS; i++){
		int custTimeLeft = gs->getCustomer(i)->getAllottedTime();
		gs->getCustomer(i)->setTimeLeft(custTimeLeft);
	}

	//Make sure the chef's health is at maximum;
	gs->getChef()->setHealth(gs->getChef()->getMaxHealth());

	//Make sure the score is set to zero
	gs->setScore(0);
	
	SDL_Event event;
	if(multiplayer){
		//draw multiplayer game, need to change so takes MPGameState as well

		int players = network->getPlayerCount();

		int myid = network->getClientID();

		network->sendOpponentViewReq((myid+1)%players);
		
//		mpgs->getGameState()->getChef()->setCharacter(mpCharacters[(myid+1)%players]);

		listener = new MPGameActionListener(this);
		graphics->initMPGameScrn(listener, mpCharacters, mpNames, numPlayers);
		network->sendState(gs);

	}
	else{
		listener = new SPGameActionListener(this);
		graphics->initSPGameScrn(listener);
		graphics->drawSPGame(gs);
	}

	while(!done)
	{
		SDL_Delay(20);
		oldtime = newtime;
		newtime = CFileTime::GetCurrentTime();
		int elapsed_confused = 0;
		if (gs->getCursor()->getModifier() == 1){
			elapsed_confused = (int) (confusedTimer - time(NULL)); //updates time value of confused timer
			//printf("elapsed: %d, current time: %d, confused timer: %d\n", elapsed_confused,  time(NULL), confusedTimer);
		}
		if (elapsed_confused < 0){
			gs->getCursor()->setModifier(0);
		}
		
		counter++;
		if(multiplayer){
			//draw multiplayer game, need to change so takes MPGameState as well
			
			processMP();

			FoodType t;

			t = mpgs->getGameState()->getBoard(0,0)->getType();

			//if(counter%50==0)
			//	printf("Foodtype %d/n",t);

			if(gameover)
				printf("about to redraw");

			graphics->drawMPGame(gs,mpgs,showSandwichMenu,numPlayers);
		}
		else{
			graphics->drawSPGame(gs);
		}
	
        col_curr = gs->getCursor()->getPosition()->getY();
	    row_curr = gs->getCursor()->getPosition()->getX();
		align_curr = gs->getCursor()->getAlignment();

		if(gameover)
				printf("about to poll");

		if( SDL_PollEvent(&event))
		{

			graphics->handleGUIEvent(&event);

			switch(event.type){
				case SDL_MOUSEMOTION:
					//printf("We got a motion event.\n");
					//printf("Current mouse position is: (%d, %d)\n", event.motion.x, event.motion.y);
					break;
				case SDL_KEYDOWN:
					
					if(event.key.keysym.sym==LEFT){
						if (gs->getCursor()->getModifier() == 1){
							moveRight(col_curr, align_curr);
						}
						else {
							moveLeft(col_curr, align_curr);
						}
					}
					if(event.key.keysym.sym==RIGHT){
						if (gs->getCursor()->getModifier() == 1){
							moveLeft(col_curr, align_curr);
						}
						else {
							moveRight(col_curr, align_curr);
						}
					}
					if(event.key.keysym.sym==UP){
						if (gs->getCursor()->getModifier() == 1){
							moveDown(row_curr, align_curr);
						}
						else {
						moveUp(row_curr, align_curr);
						}
					}
					if(event.key.keysym.sym==DOWN){
						if (gs->getCursor()->getModifier() == 1){
							moveUp(row_curr, align_curr);
						}
						else {
							moveDown(row_curr, align_curr);
						}
					}
					if(event.key.keysym.sym==SWAP){
						swap(row_curr, col_curr, align_curr);
					}
					if(event.key.keysym.sym==ROTATE){
						rotate(row_curr, col_curr, align_curr);
					}
					if(event.key.keysym.sym==SUBMIT_CUST){
						submit_cus();
					}
					if(event.key.keysym.sym==SUBMIT_SELF){
						submit_self();
					}
					if (event.key.keysym.sym==SUBMIT_OPPONENT){
						if (multiplayer){
							submit_opponent();
						}
					}
		
					if(event.key.keysym.sym==QUIT){
						printf("Exiting loop");
						done = true;
						state = EXIT;
						if(multiplayer){
							network->disconnect();
							graphics->killMPGameScrn();
						}
						else{
							graphics->killSPGameScrn();
						}
					}
					if(event.key.keysym.sym==SDLK_y){
						//network->sendSandwich(0,CONFUSE);
						handleSpecialSandwich(CONFUSE);
					}
					break;
				case SDL_QUIT:
					printf("Exiting loop");
					done = true;
					state = EXIT;
					if(multiplayer){
						network->disconnect();
						graphics->killMPGameScrn();
					}
					else{
						graphics->killSPGameScrn();
					}
					break;
				case SDL_KEYUP:
					break;
				default:
					//printf("Unhandled Event!\n");
					break;
			}
		}
		if(gameover)
				printf(" poll");
		//update food pieces, changing states if necessary
		gs->updateFoodPieces(0);

		removed = gs->updateCustomers();

		for(int i=0;i<removed;i++){
			// make yourself eat sandwich because haven't 
			// submitted to customer in time		
			submit_penalty();

			//printf("Removed customer, eating sandwich\n");
		}
		
		//If I'm not dead, send my state to the server
		if(multiplayer&&!gs->getChef()->isDead()){
			if(counter%25==0){
				//printf("sending state\n");
				network->sendState(gs);
			}
		}

		if(gameover)
			printf("about to poll");
		
		if(state!=SP_GAME&&state!=MP_GAME){
			done = true;
		}
		else if(gs->getChef()->isDead()){
			if(multiplayer){
				if(!sentover){
					network->sendGameOver();
					sentover = true;
				}
			}
			else{
				done = true;
				state = HIGH_SCORES; 
			}
		}

		if(gameover)
			printf("about to do something");
		//multiplayer game is over
		if(gameover){
			printf("doing something");
			int i = 0;
			int j = 0;

//			while(rankings[i]!=-1){
//				printf("%d", rankings[i]);
//				i++;
//			}
//
//			i--;

			i = numPlayers-1;

			char** rankedNames = new char*[i+1];
printf("2");
			BustaModelCharacter* rankedCharacters = new BustaModelCharacter[i+1];
//printf("3");
//			if(i+1!=numPlayers){
//				printf("Thought %d people were playing, got %d players ranked",numPlayers,i+1);
//				numPlayers = i;
//			}
//printf("4");

			int* rankedScores = new int[i+1];

			int id;
			for(i; i>=0; i--){
				id = rankings[i];
				rankedScores[j] = scores[i];
				rankedNames[j] = mpNames[id];
				rankedCharacters[j] = mpCharacters[id];
				j++;
			}
			printf("gameover, about to kill screen");
			graphics->killMPGameScrn();
			printf("killed game screen");
			state = MP_RANKING;
			displayRankings(rankedNames,rankedScores, rankedCharacters);
			printf("done display rankings");
			network->disconnect();
			done = true;
		}
	
		if(setOppGraphics==false){
			graphics->setOpponents(mpgs,numPlayers);
			if(counter>500){
				setOppGraphics = true;
			}
		}
	} 
}


void BustaEngine::displayRankings(char** rankedNames, int* scores, BustaModelCharacter* rankedCharacters){
	const int I_PLAY_AGAIN = SDLK_p;
	const int I_MAIN_MENU = SDLK_m;
	
	printf("entered ranking screen\n");


	MPRankingActionListener* listener = new MPRankingActionListener(this);
	graphics->initRankings(listener);


	bool done = false;
	SDL_Event event;

	while(!done)
	{
		SDL_Delay(25);
		
		graphics->drawRankings(rankedNames, numPlayers,rankedCharacters,scores);

		if( SDL_PollEvent(&event))
		{
			graphics->handleGUIEvent(&event);

			switch(event.type){
				case SDL_QUIT:
					done = true;
					state = EXIT;
				default:
					//printf("Unknown input, try again!\n");
					break;
			}
		}

		if(state!=MP_RANKING){
			done = true;
		}
	} 
	graphics->killRankings();
}

char* BustaEngine::netInit(){
	char* error = network->init();

	if(error !=NULL){
		printf("Error initializing the networking client");	
	}
	return error;

}

char* BustaEngine::connectIP(char* ip){
	char* conresp;

	printf("Connecting to: %s\n\n", ip);
	conresp = network->connect(ip, 23427);

	if(conresp!=NULL){
		printf("Error connecting to the specified server");
		return conresp;
	}

	return NULL;

}


int BustaEngine::moveLeft(int col_curr, int align_curr){	   
		if ((col_curr > 0)&& !(col_curr == 1 && align_curr == 0)){
			col_curr--;
			//printf("movedLeft \n");
			gs->getCursor()->getPosition()->setY(col_curr);
			return 1;
		}
		return 0;
}

int BustaEngine::moveRight(int col_curr, int align_curr){
		if (((col_curr < WIDTH - 1) && !(col_curr == WIDTH - 2 && align_curr == 2))){
			col_curr++;
			//printf("movedRight \n");
			gs->getCursor()->getPosition()->setY(col_curr);
			return 1;
		}
		return 0;
}

int BustaEngine::moveDown(int row_curr, int align_curr){
		if ((row_curr < HEIGHT - 1) && !(row_curr == HEIGHT - 2 && align_curr == 3)){
			row_curr++;
			//printf("movedDown \n");
			gs->getCursor()->getPosition()->setX(row_curr);
			return 1;
		}
		return 0;
}
int BustaEngine::moveUp(int row_curr, int align_curr){
		if ((row_curr > 0) && !(row_curr == 1 && align_curr == 1)){
			row_curr--;
			//printf("movedUp \n");
			gs->getCursor()->getPosition()->setX(row_curr);
			return 1;
		}
		return 0;
}

int BustaEngine::rotate(int row_curr, int col_curr, int align_curr){
	switch(align_curr){
		case 0: //left
			if (col_curr == WIDTH - 1 && row_curr == 0){
				align_curr = 3;
			}
			else if(row_curr == 0){
				align_curr = 2;	
			}
			else {
				align_curr = (align_curr + 1)%4;
			}
			break;
		case 2: //right
			if (col_curr == 0 && row_curr == HEIGHT - 1){
				align_curr = 1;
			}
			else if(row_curr == HEIGHT - 1){
				align_curr = 0;
			}
			else {
				align_curr = (align_curr + 1)%4;
			}
			break;
		case 1: // up
			if (col_curr == WIDTH - 1 && row_curr == HEIGHT - 1){
				align_curr = 0;
			}
			else if(col_curr == WIDTH - 1){
				align_curr = 3;
			}
			else{ 
				align_curr = (align_curr + 1)%4;
			}
			break;
		case 3: // down
			if (col_curr == 0 && row_curr == 0){
				align_curr = 2;
			}
			else if(col_curr == 0){
				align_curr = 1;
			}
			else{ 
				align_curr = (align_curr + 1)%4;
			}
			break;
	}
	gs->getCursor()->setAlignment(align_curr);
	return 1;
}

int BustaEngine::swap(int row_curr, int col_curr, int align_curr){ 
	BustaModelFoodPiece* curr_cursor = gs->getBoard(row_curr, col_curr);
	BustaModelFoodPiece* temp = curr_cursor;
	//printf("align value: %d\n", align_curr);
	switch (align_curr){
		case 0: //Left
			 if (col_curr > 0){
				BustaModelFoodPiece* second_cursor = gs->getBoard(row_curr, col_curr - 1);
				gs->setBoard(row_curr, col_curr, second_cursor);
				gs->setBoard(row_curr, col_curr - 1, temp);
				return 1;
			 }
			 break;
		case 2: //Right
			 if (col_curr < 4){
				BustaModelFoodPiece* second_cursor = gs->getBoard(row_curr, col_curr + 1);
				gs->setBoard(row_curr, col_curr, second_cursor);
				gs->setBoard(row_curr, col_curr + 1, temp);			
				return 1;
			 }
			 break;
		case 1: //Up
			 if (row_curr > 0){
			    BustaModelFoodPiece* second_cursor = gs->getBoard(row_curr - 1, col_curr);
				gs->setBoard(row_curr, col_curr, second_cursor);
				gs->setBoard(row_curr - 1, col_curr, temp);			
				return 1;
			 }
			 break;
		case 3: //Down
			 if (row_curr < 4){
			    BustaModelFoodPiece* second_cursor = gs->getBoard(row_curr + 1, col_curr);
				gs->setBoard(row_curr, col_curr, second_cursor);
				gs->setBoard(row_curr + 1, col_curr, temp);			
				return 1;
			 }
			 break;
	}
	
	return 0;
}

BustaModelCompleteSandwich* BustaEngine::submit_cus(){
	BustaModelCompleteSandwich* yum = new BustaModelCompleteSandwich();
	for (int i = 0; i < WIDTH; i++){
		BustaModelFoodPiece* ingr = gs->getBoard(HEIGHT - 1, i);
		yum->setIngredient(ingr, i);
	}
	setSandwichState(yum);

	// get the submitted sandwich as a list of types
	FoodType yumTypes[5];
	for (int i = 0; i <	WIDTH; i++)
		yumTypes[i] = yum->getIngredient(i)->getType();

	graphics->submissionAlert(yum);
	
	bool cust_sand;						// whether or not the sandwich created matches a customer order
	//bool inSand;						// whether or not a single ingredient in the sandwich is correct
	BustaModelFoodPiece** custOrder;	// customer's order
	FoodType custOrderTypes[5];			// the customer's order represented as types only
	//bool used[WIDTH];					// marks which ingredients were already used when checking orders
	int curr_queue = NUMCUSTOMERS - 1;	// customer whose order we are checking against

	// iterate across all the customers
	while (curr_queue >= 0)
	{
		// get the customer's order
		custOrder = gs->getCustomer(curr_queue)->getOrder();

		// get the customer's foodtype from the order
		for (int i = 0; i <	WIDTH; i++)
			custOrderTypes[i] = custOrder[i]->getType();

		// we have a customer's sandwich if it matches the submitted sandwich
		cust_sand = sandwichMatch(custOrderTypes, yumTypes);

		// if we met one of the customer's orders we don't need to check the rest of them
		if (cust_sand)
			break;
		else
			curr_queue--;		// otherwise move to next customer
	}

	if (cust_sand){
		graphics->addHistory("Fulfilled a customer order!");
			BustaModelCustomer* c = gs->getCustomer(curr_queue);
			
			if (yum->getState() == 1){ //submitted fresh sandwich
				int score_multiplier = c->getTime();
			
				gs->removeCustomer(c);
	
				int add_score = 15 * score_multiplier;
				int score = gs->getScore();
	
				score += add_score;
				gs->setScore(score);
	
				gs->getTipJar()->addTips(7);
			}

			else if (yum->getState() == 0){ //submitted normal sandwich
				int score_multiplier = c->getTime();
			
				gs->removeCustomer(c);
	
				int add_score = 10 * score_multiplier;
				int score = gs->getScore();
	
				score += add_score;
				gs->setScore(score);
	
				gs->getTipJar()->addTips(3);
			}
		else if (yum->getState() == -1){ //submitted rotten sandwich no tip
				int score_multiplier = c->getTime();
			
				gs->removeCustomer(c);
	
				int add_score = 5 * score_multiplier;
				int score = gs->getScore();
	
				score += add_score;
				gs->setScore(score);
			}


	}
	else{
		graphics->addHistory("Sorry, no customer requested that sandwich: eat up!");
		submit_penalty();
	}
	
	submit_board();

	return yum; //Rohit, I changed this -RWB
}

BustaModelCompleteSandwich* BustaEngine::submit_self(){
	BustaModelCompleteSandwich* yum = NULL;
	
	if (gs->getTipJar()->isfull()){

		yum = new BustaModelCompleteSandwich();

		for (int i = 0; i < WIDTH; i++){
			BustaModelFoodPiece* ingr = gs->getBoard(HEIGHT - 1, i);
			yum->setIngredient(ingr, i);
		}
		setSandwichState(yum);

		graphics->submissionAlert(yum);

	// handle if it is a special sandwich
		printf("about to handle special sandwich");
		handleSpecialSandwich(isSpecialSandwich(yum));
		submit_board();
	}
	return yum;
}

BustaModelCompleteSandwich* BustaEngine::submit_opponent()
{
	BustaModelCompleteSandwich* yum = NULL;

	if (gs->getTipJar()->isfull()){

		yum = new BustaModelCompleteSandwich();
		
		// generate the sandwich from the bottom ingredients row
		for (int i = 0; i < WIDTH; i++){
			BustaModelFoodPiece* ingr = gs->getBoard(HEIGHT - 1, i);
			yum->setIngredient(ingr, i);
		}

		setSandwichState(yum);
	
		graphics->submissionAlert(yum);

		// send the special sandwich
		int who = mpgs->getFullViewID();
		
		printf("sending special sandwich to %d of type %d\n",who, isSpecialSandwich(yum));

		graphics->addHistory("sending special sandwich");

		network->sendSandwich(who , isSpecialSandwich(yum));

		submit_board();		// remove the bottom row
	}

	return yum;			// return the sandwich sent
}

void BustaEngine::submit_board(){
	for (int row = HEIGHT - 2; row >= 0; row--){
		for(int col = 0; col < WIDTH; col++){
			BustaModelFoodPiece* temp = gs->getBoard(row, col);
			gs->setBoard(row +1 , col, temp);
		}
	}
	for (int col = 0; col < WIDTH; col++){
		int r = rand();
		int ingred = r % NUMFOODPIECES ;
		BustaModelFoodPiece* new_top = new BustaModelFoodPiece((FoodType)ingred, FRESH);
		gs->setBoard(0 , col, new_top);
	}
}

void BustaEngine::submit_penalty(){
	BustaModelCompleteSandwich* yum = new BustaModelCompleteSandwich();
	int max = gs->getChef()->getMaxHealth();
	
	for (int i = 0; i < WIDTH; i++){
		BustaModelFoodPiece* ingr = gs->getBoard(HEIGHT - 1, i);
		yum->setIngredient(ingr, i);
	}
	setSandwichState(yum);
	if(yum->getState() == -1){
		gs->getChef()->subtractHealth(max/20);
	}
	else if (yum->getState() == 0){
		gs->getChef()->subtractHealth(max/25);
	}

	else if (yum->getState() == 1){
		gs->getChef()->subtractHealth(max/30);
	}

	//submit_board();	
}


bool BustaEngine::buttonSelected(Button b, int x, int y){
	if(x>=b.box.x&&x<=b.box.x+b.box.w){
		if(y>=b.box.y&&y<=b.box.y+b.box.h){
			return true;
		}
	}
	return false;
}

BustaModelGameState* BustaEngine::getGameState(){
	return gs;
}

void BustaEngine::processMP(){
	BustaNetMsgQ* priority;
	BustaNetMsgQ* sandwich;
	BustaNetInternalMsg* message = NULL;
	int type,playerID;
	char* reason;
	bool activity;

	char buffer[256];

	activity = network->processNet();
	mpgs = network->getMPGS();
	priority = network->getPriorityQ();

	while(!priority->isEmpty()){
		message = priority->pop();
		type = message->getType();
		
		

		switch(type){
			case 3:
				playerID = ((MPPlayerDisconnect*)message)->getPlayerID();
				reason = ((MPPlayerDisconnect*)message)->getReason();
				sprintf(buffer,"Player %d quit",playerID);
				graphics->addHistory(buffer);
				printf(buffer);
				break;
			case 203:
				//printf("end game!\n");
				scores = ((MPEndGame*)message)->getPoints();
				rankings = ((MPEndGame*)message)->getRankings();
				printf("rankings: %d, %d, %d, %d\n",rankings[0],rankings[1],rankings[2],rankings[3]);
				printf("scores: %d, %d, %d, %d\n", scores[0],scores[1],scores[2],scores[3]);
				printf("Game over\n");
				gameover = true;
				break;
			case 204:
				printf("player lost");
				playerID = ((MPPlayerLost*)message)->getPlayerID();
				printf("player %d lost\n",playerID);
				sprintf(buffer,"Player %d lost\n",playerID);
				graphics->addHistory(buffer);
				break;
			case 666:
				sprintf(buffer,"Error in message received, flushing socket\n");
				graphics->addHistory(buffer);
				network->flushSocket();
				break;
			default:
				graphics->addHistory("Message of wrong type received\n");
				break;
		}

		delete message;
		message = NULL;
	}

	sandwich = network->getSandwichQ();
	
	while(!sandwich->isEmpty()){
		message = sandwich->pop();

		if(message->getType()==301){
			int recID = ((MPSpecialSandwich*)message)->getReceiverID();
			int sendID = ((MPSpecialSandwich*)message)->getSenderID();
			printf("Player %d received a special sandwich from player %d\n",recID,sendID);
			SpecialSandwich s = ((MPSpecialSandwich*)message)->getSpecialSandwich();
			sprintf(buffer,"Player %d received a special sandwich from player %d\n",recID,sendID);
			graphics->addHistory(buffer);
			if(recID==myID){
				handleSpecialSandwich(s);
			}
		}
		else if(message->getType()==666){
			printf("Error message received\n");
		}
		else{
			printf("Improper message placed on sandwich queue\n");
		}

		delete message;
		message = NULL;
	}

	if(gameover){
		printf("leaving process messages");
	}
}

void BustaEngine::handleSpecialSandwich(SpecialSandwich s){
	printf("Handling special sandwich received, sandwich %d",s);
	
	int max;
	int custTimeLeft;		// amount of time left for the customer's order

	switch(s){
		case LOSE_WEIGHT:			/* lose weight */
			max = gs->getChef()->getMaxHealth();
			gs->getChef()->addHealth(max/10);
			break;
		case FRESHEN:				/* freshen ingredients */
			gs->updateFoodPieces(1);
			break;
		case STEAL:                  /* increase tips */
			if (multiplayer){
				int tips = gs->getTipJar()->getTips();		// get the max size of tip jar
				gs->getTipJar()->subtractTips(tips);    // empty tip jar
			}
			break;
		case ENERGY_BOOST:			/* increase customer timers */			
			// iterate across all customers and raise time left
			for (int i = NUMCUSTOMERS-1; i >= 0; i--)
			{
				custTimeLeft = gs->getCustomer(i)->getTime();			// get the time left on the customer
				gs->getCustomer(i)->setTimeLeft(custTimeLeft * (5/4));	// give them 25% more time
			}
			break;
		case GAIN_WEIGHT:			/* lose health */
			if (multiplayer){
				max = gs->getChef()->getMaxHealth();
				gs->getChef()->subtractHealth(max/10);
			}
			break;
		case SPOIL:					/* spoil ingredients */
			if (multiplayer){
				gs->updateFoodPieces(-1);
			}
			break;
		case JUMBLE:	/* jumble ingredients grid */
			if (multiplayer){
				gs->jumbleBoard();	
			}
			break;
		case CONFUSE:				/* confuse modifier on cursor */
			if (multiplayer){
				gs->getCursor()->setModifier(1);			// set modifier on cursor
				confusedTimer = time(NULL) + confusedTime;
			}
			//printf("confusedTimer set to: %d\n", confusedTimer);
			break;
		case ENERGY_ZAP:			/* decrease timers on customers */
			// iterate across all customers and lower time left
			if (multiplayer){
			for (int i = NUMCUSTOMERS-1; i >= 0; i--)
			{
				custTimeLeft = gs->getCustomer(i)->getTime();			// get the time left on the customer
				gs->getCustomer(i)->setTimeLeft(custTimeLeft * (3/4));	// give them 25% less time
			}
			}
			break;
		case NOTASANDWICH:			/* was not a special sandwich */
			break;
		default:
			break;
	}

}

SpecialSandwich BustaEngine::isSpecialSandwich(BustaModelCompleteSandwich* sandwich)
{
	SpecialSandwich ssMatch = NOTASANDWICH;

	/* Create a list of the sandwich ingredient types only */
	FoodType sandwichType[WIDTH];
	for (int i = 0; i <	WIDTH; i++)
		sandwichType[i] = sandwich->getIngredient(i)->getType();

	/* Check against all special sandwiches */
	if (sandwichMatch(sandwichType, ssLoseWeight))			// lose weight
		ssMatch = LOSE_WEIGHT;
	else if (sandwichMatch(sandwichType, ssFreshen))		// freshen
		ssMatch = FRESHEN;
	else if (sandwichMatch(sandwichType, ssSteal))			// steal tips
		ssMatch = STEAL;
	else if (sandwichMatch(sandwichType, ssEnergyBoost))	// increase customer timers
		ssMatch = ENERGY_BOOST;
	else if (sandwichMatch(sandwichType, ssGainWeight))		// feed opponent
		ssMatch = GAIN_WEIGHT;
	else if (sandwichMatch(sandwichType, ssSpoil))			// spoil opponent ingredients
		ssMatch = SPOIL;
	else if (sandwichMatch(sandwichType, ssJumble))			// jumble opponent board
		ssMatch = JUMBLE;
	else if (sandwichMatch(sandwichType, ssConfuse))		// confuse opponent cursor
		ssMatch = CONFUSE;
	else if (sandwichMatch(sandwichType, ssEnergyZap))		// lower opponent customer timers
		ssMatch = ENERGY_ZAP;
		
	return ssMatch;
}

bool BustaEngine::sandwichMatch(FoodType* sandwichOne, FoodType* sandwichTwo)
{
	bool cust_sand;		// whether or not the sandwich created matches a customer order
	bool inSand;		// whether or not a single ingredient in the sandwich is correct
	bool used[WIDTH];	// marks which ingredients were already used when checking orders
	
	bool same_sand = true;	// whether or not the two sandwiches are the same

	// reset the list of used ingredients
	for (int i = 0; i < WIDTH; i++)
		used[i] = false;

	// iterate across all ingredients in sandwich
	for (int s = 0; s < WIDTH; s++)
	{
		inSand = false;		// assume ingredient is not in order

		// iterate across all ingredients in customer's order
		for (int i = 0; i < WIDTH; i++)
		{
			// if the ingredient in the sandwich matches any in the customer's order
			if ( (sandwichOne[s] == sandwichTwo[i]) &&		// match an ingredient
				 (!(used[i]))								// and it hasn't been used
				)
			{
				inSand = true;		// this ingredient is in the sandwich
				used[i] = true;		// and this ingredient has now been used
				break;				// move to the next ingredient
			}
		}

		// if the ingredient was not in the sandwich
		if (!inSand)
		{
			same_sand = false;		// not the same sandwich
			break;					// done checking
		}
	}

	return same_sand;
}

void BustaEngine::setSandwichState(BustaModelCompleteSandwich* sandwich){
	sandwich->setState(1);
	bool is_normal = false;
	bool is_rotten = false;
	for (int i = 0; i<WIDTH ; i++){
		BustaModelFoodPiece* ingred = sandwich->getIngredient(i);
		if (ingred->getState() == NORMAL){
			is_normal = true;
		}
		else if (ingred->getState() == ROTTING){
			is_rotten = true;
		}
	}
	if (is_rotten){
		sandwich->setState(-1);
	}
	else if (is_normal){
		sandwich->setState(0);
	}
}

void BustaEngine::writeHighScores(){
	ofstream file (HIGHSCORE_PATH,ios::trunc);
	if(! file.is_open())
		printf("Error opening High Scores File.\n");
	else{
		for(int i=0;i<10;i++){
			file.write(HSnames[i],20);
			file << "\n";
			file.write(itoa(HSscores[i],HSbuffer,10),20);
			file << "\n";
		}
	file.close();
	}
}
