#include "BustaEngineActionListeners.h"


ConnectScrnActionListener::ConnectScrnActionListener(BustaEngine* e)
{
	engine = e;
}

void ConnectScrnActionListener::action(const std::string& eventId)
{
    if (eventId == CS_CONNECT_BUTTON_ID)
    {
		printf("Connect button pressed.\n");
		engine->c_state = CS_CONNECTING;

	}
    else if (eventId == CS_CANCEL_BUTTON_ID)
    {
		printf("Cancel button pressed.\n");
		if(engine->c_state==CS_CONNECTED||engine->c_state==CS_READY){
			engine->network->disconnect();
		}
		engine->c_state = CS_CANCEL;
	}
	else if (eventId == CS_READY_BUTTON_ID)
    {
		printf("Ready button pressed.\n");
		engine->c_state = CS_READY;	
	}
    else if (eventId == CS_DISCONNECT_BUTTON_ID)
    {
		engine->c_state = CS_NOT_CONNECTED;
		engine->network->disconnect();
	

		printf("Disconnect button pressed.\n");
    }
}     

CharSelectActionListener::CharSelectActionListener(BustaEngine* e, BustaModelPosition* c)
{
	engine = e;
	cursor = c;
}

void CharSelectActionListener::action(const std::string& eventId)
{

    if (eventId == CHAR_SEL_SELECT_BUTTON_ID)
    {
		printf("char selected");
		BustaModelCharacter chef = engine->selectChef(cursor);
		engine->gs->getChef()->setCharacter(chef);
		if(engine->multiplayer){
			engine->network->sendCharSelect(chef);
			engine->mpCharacters[engine->myID] = chef;	
		}
		else{
			engine->state = SP_GAME;
		}
	}
    else if (eventId == CHAR_SEL_CANCEL_BUTTON_ID)
    {
		printf("Cancel button pressed.\n");
		if(engine->multiplayer){
			engine->network->disconnect();
			engine->state = CONNECT;
		}
		else{
			engine->state = MAIN_MENU;
		}
	}
    else if (eventId == "Chef0")
    {
		cursor->setX(0);
		cursor->setY(0);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
	else if (eventId == "Chef1")
    {
		cursor->setX(1);
		cursor->setY(0);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
	else if (eventId == "Chef2")
    {
		cursor->setX(2);
		cursor->setY(0);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
	else if (eventId == "Chef3")
    {
		cursor->setX(3);
		cursor->setY(0);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
	else if (eventId == "Chef4")
    {
		cursor->setX(0);
		cursor->setY(1);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
	else if (eventId == "Chef5")
    {
		cursor->setX(1);
		cursor->setY(1);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
	else if (eventId == "Chef6")
    {
		cursor->setX(2);
		cursor->setY(1);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
	else if (eventId == "Chef7")
    {
		cursor->setX(3);
		cursor->setY(1);
		if(engine->multiplayer){
			engine->network->sendCursor(cursor);
		}
	}
}  


SPGameActionListener::SPGameActionListener(BustaEngine* e)
{
	engine = e;
}

void SPGameActionListener::action(const std::string& eventId)
{
    if (eventId == CUSTOMER_BUTTON_ID)
    {
		printf("customer submit button pressed");
		engine->submit_cus();
	}
    else if (eventId == SELF_BUTTON_ID)
    {
		printf("self submit button pressed");	
		engine->submit_self();
	}
    else if (eventId == END_GAME_BUTTON_ID)
    {
		printf("end game button pressed");
		engine->state = MAIN_MENU;
	}
} 

MPGameActionListener::MPGameActionListener(BustaEngine* e)
{
	engine = e;
}

void MPGameActionListener::action(const std::string& eventId)
{
    if (eventId == CUSTOMER_BUTTON_ID)
    {
		printf("customer submit button pressed");
		engine->submit_cus();
	}
    else if (eventId == SELF_BUTTON_ID)
    {
		printf("self submit button pressed");	
		engine->submit_self();
	}
	else if (eventId == MP_SUBMIT_OPPONENT_BUTTON_ID)
	{
		printf("opponent submit button pressed");
		engine->submit_opponent();
	}
	else if (eventId == MP_SHOW_SPECIAL_BUTTON_ID)
	{
		engine->showSandwichMenu = !engine->showSandwichMenu;
	}
    else if (eventId == END_GAME_BUTTON_ID)
    {
		printf("end game button pressed");
		engine->state = EXIT;
		engine->network->disconnect();
	}
	else if (eventId == "Opponent0")
	{
		if(engine->mpgs->opponents[0]->isValid()){
			engine->network->sendOpponentViewReq(0);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[0]);
		}
	}
	else if (eventId == "Opponent1")
	{
		if(engine->mpgs->opponents[1]->isValid()){
			engine->network->sendOpponentViewReq(1);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[1]);
		}
	}
	else if (eventId == "Opponent2")
	{
		if(engine->mpgs->opponents[2]->isValid()){
			engine->network->sendOpponentViewReq(2);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[2]);
		}
	}
	else if (eventId == "Opponent3")
	{
		if(engine->mpgs->opponents[3]->isValid()){
			engine->network->sendOpponentViewReq(3);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[3]);
		}
	}
	else if (eventId== "Opponent4")
	{
		if(engine->mpgs->opponents[4]->isValid()){
			engine->network->sendOpponentViewReq(4);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[4]);
		}
	}
	else if (eventId == "Opponent5")
	{
		if(engine->mpgs->opponents[5]->isValid()){
			engine->network->sendOpponentViewReq(5);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[5]);
		}
	}
	else if (eventId == "Opponent6")
	{
		if(engine->mpgs->opponents[6]->isValid()){
			engine->network->sendOpponentViewReq(6);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[6]);
		}
	}
	else if (eventId == "Opponent7")
	{
		if(engine->mpgs->opponents[7]->isValid()){
			engine->network->sendOpponentViewReq(7);
			engine->mpgs->getGameState()->getChef()->setCharacter(engine->mpCharacters[7]);
		}
	}
} 

MPRankingActionListener::MPRankingActionListener(BustaEngine* e)
{
	engine = e;
}

void MPRankingActionListener::action(const std::string& eventId)
{
	if (eventId == "Play Again")
    {
		engine->state = CONNECT;
	}
    else if (eventId == "Main Menu")
    {
		engine->state = MAIN_MENU;
	}
} 

HighScoresActionListener::HighScoresActionListener(BustaEngine* e)
{
	engine = e;
}

void HighScoresActionListener::action(const std::string& eventId)
{
	if (eventId == "OK")
    {
		engine->state = MAIN_MENU;
	}
} 

KeyBindingsActionListener::KeyBindingsActionListener(BustaEngine* e)
{
	engine = e;
}

void KeyBindingsActionListener::action(const std::string& eventId)
{
	if (eventId == "Ok")
    {
		engine->state = MAIN_MENU;
	}
	else if (eventId == "Customer Submit")
    {
		engine->settingkeybinding = true;
		engine->key = 6;
	}
	else if (eventId == "Opponent Submit")
    {
		engine->settingkeybinding = true;
		engine->key = 8;
	}
	else if (eventId == "Self Submit")
    {
		engine->settingkeybinding = true;
		engine->key = 7;
	}
	else if (eventId == "Swap")
    {
		engine->settingkeybinding = true;
		engine->key = 1;
	}
	else if (eventId == "Rotate")
    {
		engine->settingkeybinding = true;
		engine->key = 0;
	}
	else if (eventId == "Left")
    {
		engine->settingkeybinding = true;
		engine->key = 5;
	}
	else if (eventId == "Right")
    {
		engine->settingkeybinding = true;
		engine->key = 4;
	}
	else if (eventId == "Up")
    {
		engine->settingkeybinding = true;
		engine->key = 3;
	}
	else if (eventId == "Down")
    {
		engine->settingkeybinding = true;
		engine->key = 2;
	}
} 