/*	Filename:		BustaEngineActionListeners.h
 *	Description:	Busta' Sandwich action listeners for interfacing with GUI screens
 *
 */

class BustaEngine;

#ifndef BUSTA_SANDWICH_ACTIONLISTENERS
#define BUSTA_SANDWICH_ACTIONLISTENERS

#include "BustaEngine.h"
#include "../graphics/GUIChan/include/guichan/actionlistener.hpp"




class ConnectScrnActionListener : public gcn::ActionListener
{
	public:
		ConnectScrnActionListener(BustaEngine* e);

		void action(const std::string& eventId);

	private:
		BustaEngine* engine;  
};

class CharSelectActionListener : public gcn::ActionListener
{
	public:
		CharSelectActionListener(BustaEngine* e, BustaModelPosition* c);

		void action(const std::string& eventId);

	private:
		BustaEngine* engine; 
		BustaModelPosition* cursor;
};

class SPGameActionListener : public gcn::ActionListener
{
	public:
		SPGameActionListener(BustaEngine* e);

		void action(const std::string& eventId);

	private:
		BustaEngine* engine;  
};

class MPGameActionListener : public gcn::ActionListener
{
	public:
		MPGameActionListener(BustaEngine* e);

		void action(const std::string& eventId);

	private:
		BustaEngine* engine;  
};

class MPRankingActionListener : public gcn::ActionListener
{
	public:
		MPRankingActionListener(BustaEngine* e);

		void action(const std::string& eventId);

	private:
		BustaEngine* engine;  
};

class HighScoresActionListener : public gcn::ActionListener
{
	public:
		HighScoresActionListener(BustaEngine* e);

		void action(const std::string& eventId);

	private:
		BustaEngine* engine;  
};

class KeyBindingsActionListener : public gcn::ActionListener
{
	public:
		KeyBindingsActionListener(BustaEngine* e);

		void action(const std::string& eventId);

	private:
		BustaEngine* engine;  
};





#endif



