#include <stdio.h>
#include <string>
#include "../graphics/BustaGraphics.h"
#include "../networking/BustaNetClient.h"
#include "../Models/BustaModelGameState.h"
#include "BustaEngine.h"

using namespace std;



int main(int argc, char** argv){
	BustaEngine* engine = new BustaEngine();

	while(engine->getState()!=EXIT){
		switch(engine->getState()){
			case MAIN_MENU:
				engine->mainMenu();
				break;
			case OPTIONS:
				engine->optionsMenu();
				break;
			case HIGH_SCORES:
				engine->highScores();
				break;
			case CHAR_SELECT:
				if(engine->multiplayer)
					engine->characterSelectMP();
				else
					engine->characterSelectSP();
				break;
			case SP_GAME:
				engine->playGame();
				break;
			case CONNECT:
				engine->connectScreen();
				break;
			case MP_GAME:
				engine->playGame();
				break;
			case KEY_BINDINGS:
				engine->keyBindingMenu();
				break;
			case SOUNDS:
				engine->soundsMenu();
				break;
			case DIFFICULTY:
				engine->difficultyMenu();
				break;
			default:
				printf("Unknown state, returning to main menu!\n");
				engine->setState(MAIN_MENU);
				break;
		}
	}

	return 0;
}