/*
 * BustaGraphicsLayout.h
 * Defines the layout of graphical elements on the screen
 *
 * Created: July 29, 2005
 */


#ifndef BUSTAGRAPHICSLAYOUT_H
#define BUSTAGRAPHICSLAYOUT_H

#define SCREEN_RES_WIDTH		800
#define SCREEN_RES_HEIGHT		600
#define BLACK_COLOR				0X00000000

//Board Layout
#define BOARD_SIZE				5

#define MAX_OPPONENTS			8

//Health Bar Properties
#define HEALTH_BAR_WIDTH		120 //same as chef	
#define HEALTH_BAR_HEIGHT		10
#define HEALTH_BAR_BG_COLOR		0x008C8C8C //Grey
#define HEALTH_BAR_FG_COLOR		0x00E71C1C //Red
#define CHEF_MAX_HEALTH			100

//Connection Screen Layout
#define CS_BMP_FONT				"./Resource/sprites/fixedfont.bmp"
#define CS_BMP_FONT_CHAR_SET	" abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!.\?,@#$%^&*()-_+=\\/|\":"
#define CS_SERVER_IP_POS_X		100
#define CS_SERVER_IP_POS_Y		110
#define CS_IP_FIELD_LABEL_POS_X	100
#define CS_IP_FIELD_LABEL_POS_Y	90
#define CS_NAME_FIELD_X			100
#define CS_NAME_FIELD_Y			55
#define CS_CONNECT_BUTTON_POS_X 300	
#define CS_CONNECT_BUTTON_POS_Y	CS_SERVER_IP_POS_Y
#define CS_READY_BUTTON_POS_X	400
#define CS_READY_BUTTON_POS_Y	CS_SERVER_IP_POS_Y

#define CS_CANCEL_BUTTON_POS_X	650
#define CS_CANCEL_BUTTON_POS_Y	500

#define CS_CANCEL_BUTTON_ID		"Cancel"
#define CS_CONNECT_BUTTON_ID	"Connect"
#define CS_READY_BUTTON_ID		"Ready"
#define CS_DISCONNECT_BUTTON_ID	"Disconnect"
#define CS_PLAYER_LIST_ALIGN_Y	200	
#define CS_PLAYER_LIST_ALIGN_X	100
#define CS_PLAYER_LIST_GAP		40
#define CS_STATUS_LIGHT_ALIGN_X 400
#define CS_LINE_LENGTH			320
#define CS_LINE_THICKNESS		5
#define CS_BG_BOX_X				50
#define CS_BG_BOX_Y				50
#define	CS_BG_BOX_WIDTH			700
#define CS_BG_BOX_HEIGHT		500

//Special Sandwich Menu Layout
#define SPECIAL_SANDWICH_GAP			45
#define SS_TEXT_LENGTH					100
#define SS_MENU_X						430
#define SS_MENU_Y						50
//Character Selection Screen Layout
#define CHAR_SEL_CHEFS_ALIGN_X		((SCREEN_RES_WIDTH - 3*CHAR_SEL_CHEFS_GAP - 4*CHEF_WIDTH)/2) //CENTER
#define CHAR_SEL_CHEFS_ALIGN_Y		((SCREEN_RES_HEIGHT - CHAR_SEL_CHEFS_GAP - 2*CHEF_HEIGHT)/2) //CENTER
#define CHAR_SEL_CHEFS_GAP			40
#define CHAR_SEL_SELECT_BUTTON_ID	"Select"
#define CHAR_SEL_SELECT_BUTTON_X	700
#define CHAR_SEL_SELECT_BUTTON_Y	500
#define CHAR_SEL_CANCEL_BUTTON_ID	"Cancel"
#define CHAR_SEL_CANCEL_BUTTON_X	700
#define CHAR_SEL_CANCEL_BUTTON_Y	540
#define CHAR_SEL_CURSOR_COLOR		0x00E71C1C //Red
#define CHAR_SEL_OTHER_CURSOR_COLOR	0x00D426A5	//Pink
#define CHAR_SEL_CHEF_BACKGROUND	0xcdc5bf  //tanish


//Customer's Order Display properties
#define ORDER_OVERLAP			25 //How much the next piece should move to the right from the left edge of the previous food piece
#define ORDER_LENGTH			5
#define CURRENT_CUSTOMER_HIGHLIGHT_COLOR	0X00F7941C //Orange

//SP Game Screen Layout
#define BOARD_TOP_LEFT_X	    140	
#define BOARD_TOP_LEFT_Y		75
#define FOOD_PIECE_GAP			0
#define SCORE_POS_X				5	
#define SCORE_POS_Y				40
#define CHEF_TOP_LEFT_POS_X		5
#define CHEF_TOP_LEFT_POS_Y		350
#define HEALTH_BAR_POS_X		5
#define HEALTH_BAR_POS_Y		520
#define ORDER_POS_X				5
#define ORDER_POS_Y				(CUSTOMER_POS_Y+CUSTOMER_HEIGHT)	
#define TIP_JAR_POS_X			130	
#define TIP_JAR_POS_Y			440
#define CUSTOMER_POS_X			5	
#define CUSTOMER_POS_Y			75
#define CUSTOMER_TIME_BAR_WIDTH	(SMALL_FOOD_PIECE_SIZE*5 - CUSTOMER_WIDTH - 5)
#define CUSTOMER_BUTTON_X		190
#define CUSTOMER_BUTTON_Y		400
#define CUSTOMER_BUTTON_ID		"Customer"
#define SELF_BUTTON_X			250	
#define SELF_BUTTON_Y			400
#define SELF_BUTTON_ID			"Self"
#define END_GAME_BUTTON_X		250
#define END_GAME_BUTTON_Y		520
#define END_GAME_BUTTON_ID		"End Game"
#define HISTORY_TEXT_BOX_X		190
#define HISTORY_TEXT_BOX_Y		440
#define HISTORY_INIT_TEXT		"                              \n\n\n\n\n" //GUIChan sets the size of the textbox by the initial string. This string creates a box with 6 lines and 30-char wide. The first line is always a blank line with 30 spaces.
#define HISTORY_TEXT_LINES		6		//The first line must always be a blank line with 30 spaces.
#define HISTORY_TEXT_LINE_CHARS	30		//number of chars in one line
#define HISTORY_BOX_FILLER		"                              "
#define SP_BG_COLOR				0xd2b48c//Light Blue

//MP Game Screen Layout
#define MP_BOARD_TOP_LEFT_X	    (BOARD_TOP_LEFT_X + SCREEN_RES_WIDTH/2)
#define MP_BOARD_TOP_LEFT_Y		75
#define MP_SCORE_POS_X			(SCREEN_RES_WIDTH/2 + 5)	
#define MP_SCORE_POS_Y			40
#define MP_CHEF_TOP_LEFT_POS_X		(SCREEN_RES_WIDTH/2 + 5)
#define MP_CHEF_TOP_LEFT_POS_Y		350
#define MP_HEALTH_BAR_POS_X		(SCREEN_RES_WIDTH/2 + 5)
#define MP_HEALTH_BAR_POS_Y		520
#define MP_ORDER_POS_X				(SCREEN_RES_WIDTH/2 + 5)
#define MP_ORDER_POS_Y				(CUSTOMER_POS_Y+CUSTOMER_HEIGHT)	
#define MP_TIP_JAR_POS_X			MP_BOARD_TOP_LEFT_X
#define MP_TIP_JAR_POS_Y			440
#define MP_CUSTOMER_POS_X			(SCREEN_RES_WIDTH/2 + 5)
#define MP_CUSTOMER_POS_Y			75

#define MP_OPPONENT_BUTTON_WIDTH	100
#define MP_OPPONENT_BUTTON_HEIGHT	50
#define MP_OPPONENTS_ALIGN_X		(MP_BOARD_TOP_LEFT_X + (FOOD_PIECE_SIZE*BOARD_SIZE) - (MP_OPPONENT_BUTTON_WIDTH*2 - 5))
#define MP_OPPONENTS_ALIGN_Y		400
#define MP_OPPONENT_PORTRAIT_SIZE	32
#define MP_SUBMIT_OPPONENT_BUTTON_X		310 
#define MP_SUBMIT_OPPONENT_BUTTON_Y		400
#define MP_SUBMIT_OPPONENT_BUTTON_ID	"Opponent"
#define MP_SHOW_SPECIAL_BUTTON_X		410
#define MP_SHOW_SPECIAL_BUTTON_Y		575
#define MP_SHOW_SPECIAL_BUTTON_ID		"Show Special Menu"
#define MP_CLOSE_SPECIAL_BUTTON_ID		"Close Special Menu"
#define MP_OPPONENT_MONEY_BAR_COLOR		0X0033D622 //GREEN

//Sandwich Crusher Layout
#define CRUSHER_X				115
#define CRUSHER_Y				330
#define	CRUSHER_FOODX			140
#define CRUSHER_FOODY			330
#define CRUSHER_DELAY			750

//Key Binding screen layout
#define KB_CUSTOMER_SUBMIT_BUTTON_ID	"Customer Submit"
#define KB_OPPONENT_SUBMIT_BUTTON_ID	"Opponent Submit"
#define KB_SELF_SUBMIT_BUTTON_ID		"Opponent Submit"
#define KB_SWAP_BUTTON_ID				"Swap"
#define KB_ROTATE_BUTTON_ID				"Rotate"
#define KB_LEFT_BUTTON_ID				"Left"
#define KB_RIGHT_BUTTON_ID				"Right"
#define KB_UP_BUTTON_ID					"Up"
#define KB_DOWN_BUTTON_ID				"Down"
#define KB_OK_BUTTON_ID					"Ok"
#define KB_BUTTONS_TOP_X				100
#define KB_BUTTONS_TOP_Y				100

//High Score Screen Layout
#define HS_TITLE_Y				50
#define HS_LISTTOP				100
#define HS_NAMELEFT				175
#define HS_SCORELEFT			525
#define HS_ENTRYHEIGHT			40
#define HS_OKBUTTON_X			400
#define HS_OKBUTTON_Y			500
#define HS_NUMSCORES			10

//Rankings Screen Layout
#define RS_TITLE_Y				50
#define RS_LISTTOP				100
#define RS_NAMELEFT				200
#define RS_ENTRYHEIGHT			40
#define RS_PLAYAGAINBUTTON_X	200
#define RS_PLAYAGAINBUTTON_Y	500
#define RS_MAINMENUBUTTON_X		400
#define RS_MAINMENUBUTTON_Y		500


//Main Screen Layout
enum MainScrnButton {MS_START_SP, MS_START_MP, MS_HIGH_SCORE, MS_OPTIONS, MS_QUIT, MS_NUM_BUTTONS};
#define MS_BG_COLOR_BLUE		0x006dcff6
#define MS_LOGO_POS_X 			0
#define MS_LOGO_POS_Y			0
//Buttons layout
#define MS_START_SP_POS_X		300
#define MS_START_SP_POS_Y		250
#define MS_START_SP_W			200
#define MS_START_SP_H			50

#define MS_START_MP_POS_X		300
#define MS_START_MP_POS_Y		300
#define MS_START_MP_W			200
#define MS_START_MP_H			50

#define MS_HIGH_SCORE_POS_X		300
#define MS_HIGH_SCORE_POS_Y		350
#define MS_HIGH_SCORE_W			200
#define MS_HIGH_SCORE_H			50

#define MS_OPTIONS_POS_X		300
#define MS_OPTIONS_POS_Y		400
#define MS_OPTIONS_W			200
#define MS_OPTIONS_H			50

#define MS_QUIT_POS_X			300
#define MS_QUIT_POS_Y			450
#define MS_QUIT_W				200
#define MS_QUIT_H				50



#endif
