/*	Filename:		BustaModelAnimation.h
 *	Description:	Busta' Sandwich Animation model.
 *
 */

#ifndef BUSTA_SANDWICH_ANIMATION
#define BUSTA_SANDWICH_ANIMATION


/**
 * @class BustaModelAnimation
 *
 */
class BustaModelAnimation
{
	public:
		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelAnimation();


		/**
		 * @brief Destructor
		 *
		 * Destructor
		 */
		~BustaModelAnimation();

		/**
		 * @brief Sets the animation bool to true
		 */
		void startAnimation();

		/**
		 * @brief sets the animation bool to false
		 */
		void stopAnimation();

		/**
		 * @brief Gets the type of animation
		 */
		int getType();

		/**
		 * @brief Sets the type of animation
		 */
		void setType(int t);
		
		/**
		 * @brief Returns the current animation frame number
		 */
		int getFrame();

		
		/**
		 * @brief Sets the current animation frame number
		 */
		void setFrame(int f);


	private:
		bool anim;
		int type;
		int frame;
};

#endif