/*	Filename:		BustaModelChef.h
 *	Description:	Busta' Sandwich Chef model.
 *
 */

#ifndef BUSTA_SANDWICH_CHEF
#define BUSTA_SANDWICH_CHEF

#include "BustaModelAnimation.h"
#include "BustaModelCharacter.h"

/**
 * @class BustaModelChef
 * @brief Chef model
 *
 *	Model representing the chef, includes health of chef
 */
class BustaModelChef
{
	public:
		/**
		 * @brief Constructor
		 *
		 * Initializes variables
		 */
		BustaModelChef();

		/**
		 * @brief Destructor
		 *
		 * Destructor
		 *
		 */
		~BustaModelChef();


		/**
		 * @brief Gets Chef's Health
		 *
		 * Gets the current health of the chef
		 */
		int getHealth();

		/**
		 * @brief Gets Chef's Health
		 *
		 * Gets the maximum health possible
		 */
		int getMaxHealth();

		/**
		 * @brief Sets Chef's health
		 *
		 * Sets the current health of the chef
		 */
		void setHealth(int h);

		/**
		 * @brief Adds to Chef's health
		 *
		 * Adds specified amount the current health of the chef
		 */
		void addHealth(int h);

		/**
		 * @brief Adds to Chef's health
		 *
		 * Subtracts specified amount the current health of the chef.
		 * If health <= 0, sets health to zero and marks chef as dead
		 */
		void subtractHealth(int h);

		/**
		 * @brief Return's character selected
		 *
		 * Returns the character that represents this chef
		 */
		BustaModelCharacter getCharacter();

		/**
		 * @brief sets character 
		 *
		 * Sets the character that represents this chef
		 */
		void setCharacter(BustaModelCharacter c);

		bool isDead();


	private:
		int health;
		int maxHealth;
		bool dead;
		BustaModelCharacter character;

};

#endif