#include "BustaModelFoodPiece.h"
#include <stdio.h>

BustaModelFoodPiece::BustaModelFoodPiece(){
	type = TOMATO;
	state = FRESH;
	immobile = false;
	switchtime = time(NULL) + FOODTIMER;
}

BustaModelFoodPiece::BustaModelFoodPiece(FoodType t, FoodState s){
	type = t;
	state = s;
	immobile = false;
	switchtime = time(NULL) + FOODTIMER;
}

BustaModelFoodPiece::BustaModelFoodPiece(FoodType t, FoodState s, bool m){
	type = t;
	state = s;
	immobile = m;
	switchtime = time(NULL) + FOODTIMER;
}

BustaModelFoodPiece::~BustaModelFoodPiece(){
}


FoodType BustaModelFoodPiece::getType(){
	return type;
}

void BustaModelFoodPiece::setType(FoodType t){
	type = t;
}

FoodState BustaModelFoodPiece::getState(){
	return state;
}


void BustaModelFoodPiece::setState(FoodState s){
	state = s;
}

bool BustaModelFoodPiece::getImmobile(){
	return immobile;
}

void BustaModelFoodPiece::setImmobile(bool i){
	immobile = i;
}

int BustaModelFoodPiece::updateState(){
	time_t currenttime = time(NULL);
	if(currenttime>=switchtime){
		if(state==ROTTING){
			state=GONE;
			return -1;
		}
		else{
			this->incrementState();
			switchtime = currenttime + FOODTIMER;
			return 1;
		}
	}
	return 0;
}

int BustaModelFoodPiece::freshenState(){
	time_t currenttime = time(NULL);
	
	if(state==FRESH){
		switchtime = currenttime + FOODTIMER;
	}
	else{
		decrementState();
	}

	return 1;
}

int BustaModelFoodPiece::spoilState(){
	time_t currenttime = time(NULL);
	
   	if(state==ROTTING){
		state=GONE;
		return -1;
	}
	else{
		this->incrementState();
		return 1;
	}
}



void BustaModelFoodPiece::incrementState()
{
	if (state == FRESH)
		state = NORMAL;
	else if (state == NORMAL)
		state = ROTTING;
	else if (state == ROTTING)
		state = GONE;
}

void BustaModelFoodPiece::decrementState()
{
	if (state == FRESH||state ==NORMAL)
		state = FRESH;
	else if (state == ROTTING)
		state = NORMAL;
	else{
		state = ROTTING;
		printf("prevented food from rotting away");
	}
}
