#include "BustaModelMPGameState.h"

BustaModelMPGameState::BustaModelMPGameState(){
	fullViewOpponentID = -1;		// no viewed opponent
	numopps = 0;
	opponentGS = NULL;
	opponents = NULL;
	SeqNo = -1;
}

BustaModelMPGameState::BustaModelMPGameState(int opponentCount)
{
	fullViewOpponentID = -1;								// no viewed opponent
	SeqNo = -1;												// invalid gamestate
	numopps = opponentCount;								// set number of brief states
	opponentGS = new BustaModelGameState();					// construct a full game state

	opponents = new BustaModelOpponent*[opponentCount];		// construct all brief gamestates
	for(int i = 0; i < numopps; i++)
		opponents[i] = new BustaModelOpponent();
}

BustaModelMPGameState::BustaModelMPGameState(BustaModelGameState* gs, BustaModelOpponent** opps, int n){
	fullViewOpponentID = -1;		// no viewed opponent
	numopps = n;
	opponents = opps;
	opponentGS = gs;
}

BustaModelMPGameState::~BustaModelMPGameState(){
	delete opponentGS;
	
	for(int i =0; i<numopps; i++){
		delete opponents[i];
	}
}

int BustaModelMPGameState::getFullViewID()
{
	return fullViewOpponentID;
}

BustaModelGameState*  BustaModelMPGameState::getGameState(){
	return opponentGS;
}

BustaModelOpponent*  BustaModelMPGameState::getOpponent(int n){
	return opponents[n];
}

BustaModelOpponent** BustaModelMPGameState::getOpponents()
{
	return opponents;
}

int BustaModelMPGameState::getSeqNo()
{
	return SeqNo;
}

void BustaModelMPGameState::setNumOpps(int opponentCount)
{
	numopps = opponentCount;
}

void BustaModelMPGameState::setFullViewID(int oID)
{
	fullViewOpponentID = oID;
}

void BustaModelMPGameState::setSeqNo(int newSeqNo)
{
	SeqNo = newSeqNo;
}
